import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.JsonNode;
import com.mashape.unirest.http.Unirest;
import com.mashape.unirest.http.exceptions.UnirestException;
import com.fasterxml.jackson.databind.ObjectMapper;

import java.io.IOException;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;


public class YouAreEll {

    YouAreEll() {
    }

   private ObjectMapper obj;

    public static void main(String[] args) {
        YouAreEll urlhandler = new YouAreEll();
        urlhandler.get_messages();
        urlhandler.get_ids();

    }

    public String get_ids() {
        StringBuilder build = new StringBuilder();
        try {
            String userJson = this.MakeURLCall("/ids", "GET", "");
             obj = new ObjectMapper();
            List<Users> myObjects = Arrays.asList(obj.readValue(userJson, Users[].class));
            for (Iterator<Users> iter = myObjects.iterator(); iter.hasNext(); ) {
                Users element = iter.next();
                build.append("Name: " + element.getName() + "\n");
                build.append("GitHub: " + element.getGithub() + "\n");
                build.append("UserID: " + element.getId() + "\n\n");
            }
        } catch (IOException e) {
            System.err.println("there is an error here");
        }
        return build.toString();
    }




    public String get_messages() {
        StringBuilder build = new StringBuilder();
        try {
            String userJson = this.MakeURLCall("/messages", "GET", "");
            //System.out.println(userJson);
            obj = new ObjectMapper();
            List<Messages> myObjects = Arrays.asList(obj.readValue(userJson, Messages[].class));
            for (Iterator<Messages> iter = myObjects.iterator(); iter.hasNext(); ) {
                Messages message = iter.next();
                format(message,build);
            }
        } catch (IOException e) {
            System.err.println("error here");
        }
        System.out.println(build.toString());
        return build.toString();


    }
    public String get_my_messages() {
        StringBuilder build = new StringBuilder();
        try {
            String userJson = this.MakeURLCall("/ids/vincesima/messages", "GET", "");
            obj = new ObjectMapper();
            List<Messages> myObjects = Arrays.asList(obj.readValue(userJson, Messages[].class));
            for (Iterator<Messages> iter = myObjects.iterator(); iter.hasNext(); ) {
                Messages element = iter.next();
                format(element, build);

            }
        } catch (IOException e) {
            System.err.println("error here");
        }
        return build.toString();

    }


    public String MakeURLCall(String mainurl, String method, String jpayload) {
        try {
            HttpResponse<JsonNode> jsonResponse = null;
            if (method.equals("GET")) {

                jsonResponse = Unirest.get("http://zipcode.rocks:8085/{method}").routeParam("method", mainurl).asJson();

            } else if (method.equals("POST")) {
                jsonResponse = Unirest.post("http://zipcode.rocks:8085/{method}")

                        .routeParam("method", mainurl)
                        .body(jpayload)
                        .asJson();
            }
           // System.out.println(((com.mashape.unirest.http.HttpResponse) jsonResponse).getBody().toString());
            return ((com.mashape.unirest.http.HttpResponse) jsonResponse).getBody().toString();


        } catch (UnirestException e) {
            return "nada";
        }

    }

    private String format(Messages message, StringBuilder build){
        build = new StringBuilder();
        build.append("From: " + message.getFromId() + "\n");
        build.append("To: " + message.getToid() + "\n");
        build.append("Message: " + message.getMessage() + "\n");
        build.append("Timestamp: " + message.getTimestamp() + "\n");
        build.append("Sequence: " + message.getSequence() + "\n\n");
        return build.toString();
    }





}
